<?php
namespace MetForm\Core\Entries;
defined( 'ABSPATH' ) || exit;

Class Form_Data{
    public static function format_form_data($form_id, $form_data){
        $map_data = \MetForm\Core\Entries\Action::instance()->get_fields($form_id);
        $map_data = json_decode(json_encode($map_data), true);
        ob_start();
        ?>
        <div class="metform-entry-data container">
            <table class='attr-table attr-table-hover'>
            <thead>
                <tr>
                <th scope="attr-col"><?php esc_html_e('Name', 'metform')?></th>
                <th scope="attr-col"><?php esc_html_e('Value', 'metform')?></th>
                </tr>
            </thead>
            <tbody>
            <?php
            foreach($map_data as $key => $value){
                if( ( $value['widgetType'] != 'mf-file-upload' ) && ( $value['widgetType'] != 'mf-simple-repeater' ) ){
                    echo "<tr>";
                    echo "<th scope='attr-row'><strong>".esc_attr(($map_data[$key]['mf_input_label'] != '') ? $map_data[$key]['mf_input_label'] : $key)."</strong></th>";
                    echo "<td>".esc_html((array_key_exists($key, $form_data) ? ((is_array($form_data[$key])) ? implode(', ', $form_data[$key]) : $form_data[$key]) : ' '))."</td>";
                    echo "</tr>";
                }

                if( $value['widgetType'] == 'mf-simple-repeater' ){
                    echo "<tr>";
                    echo "<th scope='attr-row'><strong>".esc_attr(($map_data[$key]['mf_input_label'] != '') ? $map_data[$key]['mf_input_label'] : $key)."</strong></th>";
                    echo "<td>";
                    $repeater_data = ((array_key_exists($key, $form_data)) ? $form_data[$key] : []);
                    foreach($repeater_data as $key => $value){
                        echo "<strong>".$key.": </strong>";
                        echo "<span>".$value."</span>";
                        echo "<br>";
                    }
                    echo "</td>";
                    echo "</tr>";
                }

            }
            ?>
            </tbody>
            </table>
        </div>
        <?php
        $data_html = ob_get_contents();
        ob_end_clean();
        return $data_html;
    }
}